<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top: 10px">
            <Form v-show="searchOpen" id="formId" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="委托单位:">
                <Input v-model="formObj.client" name="client" placeholder="请输入委托单位" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item class="search-item" label="合同编号:">
                <Input v-model="formObj.contractCode" name="contractCode" placeholder="请输入合同编号" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item class="search-item" label="委托编号:">
                <Input v-model="formObj.entrustCode" name="entrustCode" placeholder="请输入委托编号" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item class="search-btn">
                <Button type="primary" @click="_formSearch">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" class="contHide"
                      @on-result-change="_btnClick"></btn-list>
          </Col>
          <!--表格-->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg"  @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span v-if="item.key==='edate'">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}
                  </span>
                  <span v-else-if="item.status">{{scope.row[item.key].display}}
                  </span>
                  <span v-else-if="item.entrustType">
                      {{scope.row[item.key]===1?'出检':'送检'}}
                  </span>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <MeterEntrustSampleProgress ref="meterSampleManageModal"  @on-result-change="_page"></MeterEntrustSampleProgress>
  </div>
</template>
<script>
import { meterEntrust, meterSubcontractor } from '../../../api'
import MeterEntrustSampleProgress from './MeterEntrustSampleProgress'
export default {
  components: { MeterEntrustSampleProgress },
  data() {
    return {
      currentComponent: 'FoodSampleGovern',
      formId: 'meterEntrustProgressFormId',
      searchOpen: true,
      btn: [],
      iconMsg: [
        {
          type: 'ios-beaker',
          id: '',
          name: '样品进度'
        }
      ],
      formObj: {
        client: undefined,
        contractCode: undefined,
        entrustCode: undefined
      },
      selectIds: [],
      getPage: {},
      pageColumns: [
        { title: '委托单位', key: 'client', width: 200 },
        { title: '联系人', key: 'person', width: 120 },
        { title: '委托编号', key: 'entrustCode', width: 120 },
        { title: '委托类型', key: 'type', width: 120, entrustType: true },
        { title: '合同编号', key: 'contractCode', width: 120 },
        { title: '进度', key: 'progress', width: 120, status: true },
        { title: '联系电话', key: 'tel', width: 120 },
        { title: '传真', key: 'fax', width: 120 },
        { title: '详细地址', key: 'address', width: 250 },
        { title: '邮编', key: 'postcode', width: 130 },
        { title: 'E-mail', key: 'email', width: 150 },
        { title: '委托日期', key: 'edate', width: 120 },
        { title: '费用合计', key: 'fee', width: 120 },
        { title: '备注', key: 'remark' }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _detailModal(data) {
      console.log(data)
      this.$refs.meterSampleEdit._open(data)
    },
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '驳回':
            this._goBack()
            break
          case '添加':
            this._editModal(false)
            break
          case '通过':
            this._passReview()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _goBack() {
      // 退回
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条委托！')
      } else {
        this.$refs.reasonModal._open('退回原因')
      }
    },
    _reasonResult(data) {
      if (undefined !== data && data !== '') {
        console.log(data)
        this._reportCheckBack(data)
        console.log('退回')
      }
      console.log(data)
    },
    _reportCheckBack: async function(data) {
      const result = await meterEntrust.back({
        ids: this.selectIds,
        remark: data
      })

      if (result) {
        this.$Message.success('退回成功！')
        await this._page()
      }
    },
    _iconClick(res, data) {
      this.$nextTick(function() {
        switch (res) {
          case '样品进度':
            this._manageSample(data.id)
            break
          case '详情':
            this._detailModal(data)
            break
          case '编辑':
            this._editModal(true, data.id)
            break
          case '资质项目':
            this._itemModal(data.id)
            break
          case '附件':
            this._upload(data.id)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data.id)
            break
        }
      })
    },
    _manageSample(data) {
      // 管理样品
      this.$refs.meterSampleManageModal._open(data)
    },
    _record(id) {
      this.$refs.operation._open(id)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
        case 'changeSize':
          this._page()
          break
        case 'selectIds':
          this.selectIds = data
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await meterEntrust.pageEntrustProgress(this.formObj)
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        // 编辑
        // this.$refs.editSubcontractorModal._open(id)
        this._getById(id)
      } else {
        // 添加
        this.$refs.editSubcontractorModal._open()
      }
    },

    _passReview() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择要通过评审的委托单！')
        return false
      }
      this.$Modal.confirm({
        title: '提示',
        content: '确定通过该委托单？',
        onOk: () => {
          this._passEntrustReview(this.selectIds)
        }
      })
    },

    _passEntrustReview: async function(ids) {
      const result = await meterEntrust.passReview(ids)
      if (result) {
        this.$Message.success('提交成功！')
        await this._page()
      }
    },

    // 追加项目
    _itemModal(data) {
      this.$refs.refModal._open(data)
    },

    _upload(id) {
      // 上传文件
      this.$refs.FileManage._open(id, 'contractId')
    },
    _getById: async function(id) {
      const result = await meterSubcontractor.getById(id)
      if (result) {
        this.$refs.editSubcontractorModal._open(result)
      }
    },
    _delete: async function(ids) {
      const result = await meterSubcontractor.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    }
  }
}
</script>
